@echo off

setlocal

REM Start program

if .%1==.-? goto exitprogram

if .%1==. goto exitprogram

REM Process arguments
shift
if .%0==. goto exitprogram
set InstallLoc=%~S0
shift
if .%0==. goto exitprogram
set BackDir=%~0
set JndiCheck=jndi
shift
set Jndi=%0

@echo Checking input parameters
if not exist %InstallLoc% goto :paramError
if not exist %BackDir% mkdir %BackDir%
if not exist %BackDir% goto :paramError
if not exist "%BackDir%\etc" mkdir "%BackDir%\etc"

if not "%Jndi%"=="%JndiCheck%" goto :copyCfgAndSch
REM Backup JNDI files
if not exist "%BackDir%\java" mkdir "%BackDir%\java"
if not exist "%BackDir%\jre" mkdir "%BackDir%\jre"
if not exist "%BackDir%\jre\lib" mkdir "%BackDir%\jre\lib"
if not exist "%BackDir%\jre\bin" mkdir "%BackDir%\jre\bin"
echo copying "%InstallLoc%\java\ibmjcefw.jar" "%BackDir%\java\ibmjcefw.jar"
copy "%InstallLoc%\java\ibmjcefw.jar" "%BackDir%\java\ibmjcefw.jar"
echo copying "%InstallLoc%\java\ibmjceprovider.jar" "%BackDir%\java\ibmjceprovider.jar"
copy "%InstallLoc%\java\ibmjceprovider.jar" "%BackDir%\java\ibmjceprovider.jar"
echo copying "%InstallLoc%\java\IBMjgssprovider.jar" "%BackDir%\java\IBMjgssprovider.jar"
copy "%InstallLoc%\java\IBMjgssprovider.jar" "%BackDir%\java\IBMjgssprovider.jar"
echo copying "%InstallLoc%\java\Local_policy.jar" "%BackDir%\java\Local_policy.jar"
copy "%InstallLoc%\java\Local_policy.jar" "%BackDir%\java\Local_policy.jar"
echo copying "%InstallLoc%\java\US_export_policy.jar" "%BackDir%\java\US_export_policy.jar"
copy "%InstallLoc%\java\US_export_policy.jar" "%BackDir%\java\US_export_policy.jar"
echo copying "%InstallLoc%\java\Krb5.ini" "%BackDir%\java\Krb5.ini"
copy "%InstallLoc%\java\Krb5.ini" "%BackDir%\java\Krb5.ini"
echo copying "%InstallLoc%\java\ibmjndi.jar" "%BackDir%\java\ibmjndi.jar"
copy "%InstallLoc%\java\ibmjndi.jar" "%BackDir%\java\ibmjndi.jar"
echo copying "%InstallLoc%\java\ibmjndi.zip" "%BackDir%\java\ibmjndi.zip"
copy "%InstallLoc%\java\ibmjndi.zip" "%BackDir%\java\ibmjndi.zip"
echo copying "%InstalLoc%\jre\lib\*.*" "%BackDir%\jre\lib"
copy "%InstalLoc%\jre\lib\*.*" "%BackDir%\jre\lib"
echo copying "%InstallLoc%\jre\bin\*.*" "%BackDir%\jre\bin"
copy "%InstallLoc%\jre\bin\*.*" "%BackDir%\jre\bin"

:copyCfgAndSch
REM Backup schema and config files
echo copying "%InstallLoc%\etc\V3.modifiedschema" to "%BackDir%\etc\V3.modifiedschema"
copy "%InstallLoc%\etc\V3.modifiedschema" "%BackDir%\etc\V3.modifiedschema"
echo copying "%InstallLoc%\etc\V3.ibm.at" "%BackDir%\etc\V3.ibm.at"
copy "%InstallLoc%\etc\V3.ibm.at" "%BackDir%\etc\V3.ibm.at"
echo copying "%InstallLoc%\etc\V3.ibm.oc" "%BackDir%\etc\V3.ibm.oc"
copy "%InstallLoc%\etc\V3.ibm.oc" "%BackDir%\etc\V3.ibm.oc"
echo copying "%InstallLoc%\etc\V3.user.at" "%BackDir%\etc\V3.user.at"
copy "%InstallLoc%\etc\V3.user.at" "%BackDir%\etc\V3.user.at"
echo copying "%InstallLoc%\etc\V3.user.oc" "%BackDir%\etc\V3.user.oc"
copy "%InstallLoc%\etc\V3.user.oc" "%BackDir%\etc\V3.user.oc"
echo copying "%InstallLoc%\etc\V3.system.at" "%BackDir%\etc\V3.system.at"
copy "%InstallLoc%\etc\V3.system.at" "%BackDir%\etc\V3.system.at"
echo copying "%InstallLoc%\etc\V3.system.oc" "%BackDir%\etc\V3.system.oc"
copy "%InstallLoc%\etc\V3.system.oc" "%BackDir%\etc\V3.system.oc"
echo copying "%InstallLoc%\etc\slapd32.conf or ibmslapd.conf" "%BackDir%\etc\slapd32.conf or ibmslap.conf" 
if exist "%InstallLoc%\etc\ibmslapd.conf" goto :copyIbmSlapd
if exist "%InstallLoc%\etc\slapd32.conf" copy "%InstallLoc%\etc\slapd32.conf" "%BackDir%\etc\slapd32.conf"
goto :end
:copyIbmSlapd
copy "%InstallLoc%\etc\ibmslapd.conf" "%BackDir%\etc\ibmslapd.conf"
goto :end

:paramError
@echo Error found with input parameters.  Either the install location specified did not exist, or the backup directory did not exist and could not be created.

REM Display usage
:exitprogram
echo "usage: migbkup <install location> <backup directory> jndi"
echo "<install location> is the path to the current LDAP install, i.e. C:\Program Files\IBM\LDAP"
echo "<backup directory> is the directory where the files will be copied"
echo "jndi will backup IBM JNDI specific files, use for 3.2.2 only"
echo "This script will copy the following files from the <install location>/etc directory:"
echo "slapd.conf/ibmslapd.conf"
echo "V3.ibm.at"
echo "V3.ibm.oc"
echo "V3.system.at"
echo "V3.system.oc"
echo "V3.user.at"
echo "V3.user.oc"
echo "V3.modifiedschema"
echo "If jndi is specified, the <install location>/jre/bin and"
echo "<install location>/jre/lib directories will be copied, as"
echo "well as the following files from <install location>/java:"
echo "Ibmjcefw.jar"
echo "Ibmjceprovider.jar"
echo "IBMjgssprovider.jar"
echo "Local_policy.jar"
echo "US_export_policy.jar"
echo "Krb5.ini"
echo "Ibmjndi.jar"
echo "Ibmjndi.zip"

REM End program 
:end
